/* soapOrdersManagerBindingService.h
   Generated by gSOAP 2.8.22 from OrdersManager.h

Copyright(C) 2000-2015, Robert van Engelen, Genivia Inc. All Rights Reserved.
The generated code is released under one of the following licenses:
GPL or Genivia's license for commercial use.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
*/

#ifndef soapOrdersManagerBindingService_H
#define soapOrdersManagerBindingService_H
#include "soapH.h"
class SOAP_CMAC OrdersManagerBindingService
{ public:
	struct soap *soap;
	bool soap_own;
	/// Variables globally declared in OrdersManager.h (non-static)
	/// Constructor
	OrdersManagerBindingService();
	/// Constructor to use/share an engine state
	OrdersManagerBindingService(struct soap*);
	/// Constructor with engine input+output mode control
	OrdersManagerBindingService(soap_mode iomode);
	/// Constructor with engine input and output mode control
	OrdersManagerBindingService(soap_mode imode, soap_mode omode);
	/// Destructor, also frees all deserialized data
	virtual ~OrdersManagerBindingService();
	/// Delete all deserialized data (with soap_destroy and soap_end)
	virtual	void destroy();
	/// Delete all deserialized data and reset to defaults
	virtual	void reset();
	/// Initializer used by constructor
	virtual	void OrdersManagerBindingService_init(soap_mode imode, soap_mode omode);
	/// Create a copy
	virtual	OrdersManagerBindingService *copy() SOAP_PURE_VIRTUAL;
	/// Close connection (normally automatic)
	virtual	int soap_close_socket();
	/// Force close connection (can kill a thread blocked on IO)
	virtual	int soap_force_close_socket();
	/// Return sender-related fault to sender
	virtual	int soap_senderfault(const char *string, const char *detailXML);
	/// Return sender-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Return receiver-related fault to sender
	virtual	int soap_receiverfault(const char *string, const char *detailXML);
	/// Return receiver-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
#ifndef WITH_COMPAT
	virtual	void soap_stream_fault(std::ostream&);
#endif
	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Get SOAP Header structure (NULL when absent)
	virtual	const SOAP_ENV__Header *soap_header();
	/// Run simple single-thread (iterative, non-SSL) service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
	virtual	int run(int port);
	/// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
	/// Accept next request (returns socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET accept();
#if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
	/// Then accept SSL handshake, when SSL is used
	virtual	int ssl_accept();
#endif
	/// Serve this request (returns error code or SOAP_OK)
	virtual	int serve();
	/// Used by serve() to dispatch a request (returns error or SOAP_OK)
	virtual	int dispatch();
	virtual	int dispatch(struct soap *soap);

	///
	/// Service operations (you should define these):
	/// Note: compile with -DWITH_PURE_VIRTUAL for pure virtual methods
	///

	/// Web service operation 'GetResponseCodeString' (returns error code or SOAP_OK)
	virtual	int GetResponseCodeString(enum ns1__responseCodeType code, std::string &str) SOAP_PURE_VIRTUAL;

	/// Web service operation 'GetUserId' (returns error code or SOAP_OK)
	virtual	int GetUserId(std::string str, int &value) SOAP_PURE_VIRTUAL;

	/// Web service operation 'GetBusinessName' (returns error code or SOAP_OK)
	virtual	int GetBusinessName(int idBusiness, std::string &str) SOAP_PURE_VIRTUAL;

	/// Web service operation 'GetIdBusinessList' (returns error code or SOAP_OK)
	virtual	int GetIdBusinessList(int idParent, ns1__idListType &idBussinessList) SOAP_PURE_VIRTUAL;

	/// Web service operation 'GetUserInfo' (returns error code or SOAP_OK)
	virtual	int GetUserInfo(int idUser, ns1__clientBaseInfoType &userInfo) SOAP_PURE_VIRTUAL;

	/// Web service operation 'Registration' (returns error code or SOAP_OK)
	virtual	int Registration(ns1__clientFullInfoType *info, enum ns1__responseCodeType &code) SOAP_PURE_VIRTUAL;

	/// Web service operation 'Authorization' (returns error code or SOAP_OK)
	virtual	int Authorization(ns1__clientAuthorizationInfoType *authInfo, enum ns1__responseCodeType &code) SOAP_PURE_VIRTUAL;

	/// Web service operation 'SendOrder' (returns error code or SOAP_OK)
	virtual	int SendOrder(ns1__OrderType *order, ns1__clientAuthorizationInfoType *auth, enum ns1__responseCodeType &code) SOAP_PURE_VIRTUAL;

	/// Web service operation 'TakeOrder' (returns error code or SOAP_OK)
	virtual	int TakeOrder(int takeId, ns1__clientAuthorizationInfoType *auth, enum ns1__responseCodeType &code) SOAP_PURE_VIRTUAL;

	/// Web service operation 'FinishOrder' (returns error code or SOAP_OK)
	virtual	int FinishOrder(int finishId, ns1__clientAuthorizationInfoType *auth, enum ns1__responseCodeType &code) SOAP_PURE_VIRTUAL;

	/// Web service operation 'FindOrders' (returns error code or SOAP_OK)
	virtual	int FindOrders(ns1__OrdersQueryType *query, ns1__clientAuthorizationInfoType *auth, struct __ns1__FindOrdersResponse &_param_1) SOAP_PURE_VIRTUAL;
};
#endif
